/* and.s -- logical and operation		*/

// DNE: this file contains stuff to replace gcc's buggy "bic" AND
//
//      Author: Diane Neisius (DNE) 10/2009.
//      Free software released under the terms of the GPL.
//      See http://www.fsf.org for details.

	.globl ___andsi3, ___andhi3

___andsi3:			// 32 bit AND
	jsr	r5,csv
	mov	4(r5),r2	/ r2L = src
	mov	6(r5),r3
	mov	8(r5),r0	/ r0L = dest
	mov	10(r5),r1
	com	r2		/ r2L = !(src)
	com	r3
	bic	r2, r0		/ r0L = !( !(src) ) & dest
	bic	r3, r1
	jmp	cret

___andhi3:			// 16 bit AND
	jsr	r5,csv
	mov	4(r5),r2	/ r2 = src
	mov	6(r5),r0	/ r0 = dest
	com	r2		/ r2 = !(src)
	bic	r2, r0		/ r0 = !( !(src) ) & dest
	jmp	cret
